const GETTEXT_DOMAIN = 'my-indicator-extension';

const { GObject, St, GLib } = imports.gi;

const Gettext = imports.gettext.domain(GETTEXT_DOMAIN);
const _ = Gettext.gettext;

const ExtensionUtils = imports.misc.extensionUtils;
const Main = imports.ui.main;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;

let button, icon;

const Indicator = GObject.registerClass(
class Indicator extends PanelMenu.Button {
    _init() {
        super._init(0.0, _('My Shiny Indicator'));
        
       this.add_child(new St.Icon({
            icon_name: 'system-shutdown-symbolic',
            style_class: 'system-status-icon',
        }));

        let item3 = new PopupMenu.PopupMenuItem(_('Shutdown'));
        let item2 = new PopupMenu.PopupMenuItem(_('Reboot'));
        let item = new PopupMenu.PopupMenuItem(_('Log out'));
        
        item3.connect('button-press-event', lancage);
        item2.connect('button-press-event', redem);
        item.connect('button-press-event', reLog);

        this.menu.addMenuItem(item);
        this.menu.addMenuItem(item2);
        this.menu.addMenuItem(item3);
    }
});

class Extension {
    constructor(uuid) {
        this._uuid = uuid;

        ExtensionUtils.initTranslations(GETTEXT_DOMAIN);
    }

    enable() {
        this._indicator = new Indicator();
        Main.panel.addToStatusArea(this._uuid, this._indicator);
    }

    disable() {
        this._indicator.destroy();
        this._indicator = null;
    }
}

function init(meta) {
    return new Extension(meta.uuid);
}

function lancage() {
    let s = GLib.spawn_command_line_async('env GDK_BACKEND=x11 gnome-session-quit --power-off --no-prompt');
    if(s == false) {
	Main.notify(_("Couldn't start gnome-session-quit."));
    }
}

function redem() {
    let s = GLib.spawn_command_line_async('env GDK_BACKEND=x11 gnome-session-quit --reboot --no-prompt');
    if(s == false) {
	Main.notify(_("Couldn't start gnome-session-quit."));
    }
}

function reLog() {
    let s = GLib.spawn_command_line_async('env GDK_BACKEND=x11 gnome-session-quit --logout --no-prompt');
    if(s == false) {
	Main.notify(_("Couldn't start gnome-session-quit."));
    }
}
